<template>
  <div class="ele-body">
    <a-card :bordered="false">
      <!-- 搜索表单 -->
      <a-form
        :model="where"
        :label-col="{ md: { span: 6 }, sm: { span: 24 } }"
        :wrapper-col="{ md: { span: 18 }, sm: { span: 24 } }"
      >
        <a-row>
          <a-col :lg="6" :md="12" :sm="24" :xs="24">
            <a-form-item label="测点名称:">
              <a-select v-model:value="where.place" allowClear showSearch>
                <a-select-option
                  v-for="(item) in palceOptions"
                  :key="item.value"
                  >{{ item.label }}</a-select-option
                >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :sm="24" :xs="24">
            <a-form-item label="城区">
              <a-select v-model:value="where.area" allowClear showSearch>
                <a-select-option
                  v-for="(item) in areaOptions"
                  :key="item.value"
                  >{{ item.label }}</a-select-option
                >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :sm="24" :xs="24">
            <a-form-item class="ele-text-right" :wrapper-col="{ span: 24 }">
              <a-space>
                <a-button type="primary" @click="reload">查询</a-button>
                <a-button @click="reset">重置</a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
      <a-modal
        v-model:visible="showEdit"
        :title="form.acidRainId !== undefined ? '修改记录' : '添加记录'"
        :confirm-loading="loading"
        :width="1000"
        :body-style="{ paddingBottom: '8px' }"
        @ok="save"
      >
        <a-form
          ref="form"
          :model="form"
          :rules="rules"
          :label-col="{ md: { span: 6 }, sm: { span: 24 } }"
          :wrapper-col="{ md: { span: 18 }, sm: { span: 24 } }"
        >
          <a-row>
            <a-col :md="12" :sm="24">
              <a-form-item label="日期" name="monitorDate">
                <a-date-picker
                  v-model:value="form.monitorDate"
                  :locale="locale"
                />
              </a-form-item>
            </a-col>
            <a-col :md="12" :sm="24">
              <a-form-item label="时间" name="monitorTime">
                <a-time-picker
                  v-model:value="form.monitorTime"
                  format="HH:mm"
                />
              </a-form-item>
            </a-col>

            <a-col v-for="(item,index) in tableColumns" :key="index" :md="12" :sm="24">
              <a-form-item :label="item.title" :name="item.dataIndex">
                <a-input
                    v-model:value="form[item.dataIndex]"
                    :placeholder="'请输入' + item.title"
                    allow-clear
                />
              </a-form-item>
            </a-col>
          </a-row>
        </a-form>
      </a-modal>
      <!-- 表格 -->
      <ele-pro-table
        v-model:selection="selectionList"
        ref="table"
        row-key="acidRainId"
        :datasource="url"
        :columns="columns"
        :where="where"
        :scroll="{ x: 'max-content' }"
      >
        <template v-if="bill.checked != 1" #toolbar>
          <a-space>
            <a-button @click="openEdit" type="primary">新增</a-button>
            <a-popconfirm
              :disabled="selectionList.length == 0"
              :title="`确认删除${selectionList.length}条数据吗?`"
              ok-text="Yes"
              cancel-text="No"
              @confirm="removeBatch"
            >
              <a-button
                :disabled="selectionList.length == 0"
                type="primary"
                ghost
                danger
                >删除</a-button
              >
            </a-popconfirm>
          </a-space>
        </template>

        <template #Address="{ record  }">
         {{record.area?record.area:record.county?record.county:record.city}}
        </template>

        <template #action="{ record }">
          <a-space>
            <a-button
              @click="openEdit(record)"
              type="primary"
              shape="round"
              size="small"
              >修改</a-button
            >
            <a-popconfirm
              :title="`确认删除这条数据吗?`"
              ok-text="Yes"
              cancel-text="No"
              @confirm="remove(record)"
            >
              <a-button type="primary" danger shape="round" size="small"
                >删除</a-button
              >
            </a-popconfirm>
          </a-space>
        </template>
      </ele-pro-table>
    </a-card>
  </div>
  <!-- 编辑弹窗 -->
</template>

<script>
import _ from "lodash";
import {
  pageAcidRainUrl,
  saveAcidRain,
  removeAcidRain,
  removeBatchAcidRain,
  updateAcidRain,
  getAcidRainBill,
  getColumnOptions,
} from "@/api/ecology/atmosphere/acid";
import locale from "ant-design-vue/es/date-picker/locale/zh_CN";
import moment from "moment";
import { tableColumns } from "./colums";
export default {
  name: "ZoneCollectNoise",
  components: {},
  data() {
    const { billId } = this.$route.params;

    return {
      locale,
      bill: {},
      // 表格数据接口
      url: pageAcidRainUrl,
      selection: [],
      // 表格列配置
      columns: [
        {
          title: "采样开始时间",
          dataIndex: "monitorStartTime",
          sorter: true,
          customRender: ({text})=> moment(text,"YYYY/MM/DD HH:mm:ss").format("YYYY-MM-DD HH:mm")
        },
         {
          title: "采样结束时间",
          dataIndex: "monitorEndTime",
          sorter: true,
          customRender: ({text})=> moment(text,"YYYY/MM/DD HH:mm:ss").format("YYYY-MM-DD HH:mm")
        },
        ...tableColumns,
        {
          title: "创建人",
          dataIndex: "userName",
          sorter: true,
        },
        {
          title: "操作",
          key: "action",
          width: 150,
          align: "center",
          fixed: "right",
          slots: {
            customRender: "action",
          },
        },
      ],
      // 表格搜索条件
      acidRainBillId: billId,
      palceOptions: [],
      areaOptions: [],
      where: {
        acidRainBillId: billId,
      },
      // 表格选中数据
      selectionList: [],
      // 是否显示编辑弹窗
      showEdit: false,
      // 表单数据
      form: {},
      loading: false,
      rules: {},
    };
  },
  mounted() {
    const { billId } = this.$route.params;
    getAcidRainBill(billId).then((res) => {
      this.bill = res.data.data;
      if (res.data.data.checked == 1) {
        this.columns.splice(this.columns.length - 1, 1);
      }
    });
    this.loadOptionData();
  },
  methods: {
    /**获取下来框数据 */
    loadOptionData() {
      getColumnOptions("place").then((res) => {
        this.palceOptions = res.data.data.map((item) => {
          return {
            label: item,
            value: item,
          };
        });
      });
      getColumnOptions("area").then((res) => {
        this.areaOptions = res.data.data.map((item) => {
          return {
            label: item,
            value: item,
          };
        });
      });
    },
    /* 刷新表格 */
    reload() {

      this.$refs.table.reload({
        where: this.where,
      });
    },
    /* 重置搜索 */
    reset() {
      this.where = {
        acidRainBillId: this.acidRainBillId,
      };
      this.reload();
    },
    /* 显示编辑 */
    openEdit(record) {
      const cloneRecord = _.cloneDeep(record);
      if (record && cloneRecord.monitorTime) {
        console.log(moment(cloneRecord.monitorTime).format("YYYY MM DD"));
        cloneRecord.monitorDate = moment(cloneRecord.monitorTime);
        cloneRecord.monitorTime = moment(cloneRecord.monitorTime);
      }
      // cloneRecord.mi
      this.form = Object.assign({}, cloneRecord);
      this.showEdit = true;
      this.$nextTick(() => {
        this.$refs.form.clearValidate(); // 清除表单验证信息
      });
    },

    save() {
      const hide = this.$message.loading("请求中..", 0);
      const form = _.cloneDeep(this.form);
      const date = new Date();
      date.setFullYear(form.monitorDate.year());
      date.setMonth(form.monitorDate.month());
      date.setDate(form.monitorDate.date());
      date.setHours(form.monitorTime.hour());
      date.setMinutes(form.monitorTime.minutes());
      form.monitorTime = date.getTime();
      form.monitorYear = date.getFullYear();
      form.monitorMonth = date.getMonth() + 1;
      form.monitorDay = date.getDate();
      form.monitorHour = date.getHours();
      form.monitorMinute = date.getMinutes();
      delete form["monitorDate"];
      if (form.acidRainId) {
        updateAcidRain(form)
          .then((res) => {
            if (res.data.code == 0) {
              this.showEdit = false;
              this.$message.success(res.data.msg);
              this.reload();
            } else {
              this.$message.error(res.data.msg);
            }
          })
          .catch((error) => {
            this.$message.error(error.message);
          })
          .finally(() => {
            console.log("finallyfinallyfinallyfinally");
            hide();
          });
      } else {
        form.acidRainBillId = this.acidRainBillId;
        saveAcidRain(form)
          .then((res) => {
            if (res.data.code == 0) {
              this.showEdit = false;
              this.$message.success(res.data.msg);
              this.reload();
            } else {
              this.$message.error(res.data.msg);
            }
          })
          .catch((error) => {
            this.$message.error(error.message);
          })
          .finally(() => {
            hide();
          });
      }
    },
    /* 删除单个 */
    remove(row) {
      const hide = this.$message.loading("请求中..", 0);
      removeAcidRain(row.acidRainId)
        .then((res) => {
          if (res.data.code === 0) {
            this.$message.success(res.data.msg);
            this.reload();
          } else {
            this.$message.error(res.data.msg);
          }
        })
        .catch((e) => {
          this.$message.error(e.msg);
        })
        .finally(() => hide());
    },
    removeBatch() {
      const ids = this.selectionList.map((item) => item.acidRainId);
      const hide = this.$message.loading("请求中..", 0);
      removeBatchAcidRain(ids)
        .then((res) => {
          if (res.data.code === 0) {
            this.$message.success(res.data.msg);
            this.reload();
          } else {
            this.$message.error(res.data.msg);
          }
        })
        .catch((e) => {
          this.$message.error(e.msg);
        })
        .finally(() => hide());
    },
  },
};
</script>

<style scoped lang="less">
</style>